#include <amxmodx>
#include <cstrike>
#include <fakemeta>

const maxPlayer = 32;

new bool:g_bPlayerInvisible[ maxPlayer + 1 ],
	bool:g_bWaterInvisible[ maxPlayer 1];
	
new Array: gWaterEntity;

public plugin_init( )
{
	register_plugin( "Invis", "1.0", "DarkGL");
	
	gWaterEntity = ArrayCreate( 1 , 1 );
	
	register_clcmd( "say /invis", "menuInvisDisplay" );
	
	register_menucmd( register_menuid( "" ), 1023, "MenuInvis" );
	
	register_forward( FM_AddToFullPack, "fwdAddToFullPack_Post", 1 );
	
	register_forward( FM_CheckVisibility,"checkVisibility")
}

public plugin_cfg( )
{
	new iEnt = engfunc( EngFunc_FindEntityByString, -1, "classname", "func_water" );
	while( iEnt ){
		
		if( !pev_valid( iEnt ) ){
			continue;
		}
		
		ArrayPushCell( gWaterEntity , iEnt );
		
		iEnt = engfunc( EngFunc_FindEntityByString, iEnt, "classname", "func_water" );
	}
}

public checkVisibility(id,pset){
	if( !pev_valid( id ) ){
		return FMRES_IGNORED;
	}
	
	client_print( 0 , 3 , "visible %d | %d" , id , pset );
}

public fwdAddToFullPack_Post( es_handle, e, ent, host, hostflags, player, pset )
{
	/*if( player ){
		if(is_user_alive(host) && g_bPlayerInvisible[host] && host != ent && is_user_alive(ent) && pev_valid(ent) && pev_valid(host) && cs_get_user_team( host ) == cs_get_user_team( ent )){
			set_es( es_handle, ES_Origin, { 999999999.0, 999999999.0, 999999999.0 } );
		}
	}
	else if( g_bWaterInvisible[host] && g_bWaterEntity[ent]){
		set_es( es_handle, ES_Effects, EF_NODRAW );
	}*/
}

public menuInvisDisplay( plr )
{
	static menu[1024];
	
	
	new len = 0;
	
	
	len += format( menu[len], sizeof menu - len, "\r1. \wGracze: \y%s^n", g_bPlayerInvisible[plr] ? "Niewidoczni" : "Widoczni" );
	len += format( menu[len], sizeof menu - len, "\r2. \wWoda: \y%s^n^n", g_bWaterFound ? ( g_bWaterInvisible[plr] ? "Niewidoczna" : "Widoczna" ) : "Nie ma wody" );
	
	len += format( menu[len], sizeof menu - len, "\r0. \wWyjscie" );
	
	show_menu( plr, ( 1<<0 | 1<<1 | 1<<9 ), menu, -1 );
	
	return PLUGIN_HANDLED;
}

public MenuInvis( plr, key )
{
	switch( key )
	{
		case 0:
		{
			g_bPlayerInvisible[plr] = !g_bPlayerInvisible[plr];
			menuInvisDisplay( plr );
		}
		case 1:
		{
			g_bWaterInvisible[plr] = !g_bWaterInvisible[plr];
			menuInvisDisplay( plr );
		}
		case 9: show_menu( plr, 0, "" );
		}
}

public client_connect( plr )
{
	g_bPlayerInvisible[plr] = false;
	g_bWaterInvisible[plr] = false;
}  
