
 #include <amxmodx>
 #include <fakemeta>

 #define VERSION "0.10"

 new cvEnabled, tr, Float:plOrigin[3], Float:mins[3], Float:maxs[3];

 public plugin_init()
 {
	register_plugin("No HEGrenades Through Walls",VERSION,"Avalanche");
	register_cvar("nonadesthruwalls_ver",VERSION);
	set_cvar_string("nonadesthruwalls_ver",VERSION);

	register_forward(FM_FindEntityInSphere,"fw_sphere",0);
	cvEnabled = register_cvar("nonadesthruwalls","1");
 }

 public fw_sphere(start,Float:origin[3],Float:radius)
 {
	if(radius != 350.0 || !get_pcvar_num(cvEnabled))
		return FMRES_IGNORED;

	// run the same check to see what its result will be
	new hit = engfunc(EngFunc_FindEntityInSphere,start,origin,radius);

	// hit a non- or dead-player
	if(!is_user_alive(hit)) return FMRES_IGNORED;

	// aim for the body
	pev(hit,pev_origin,plOrigin);
	engfunc(EngFunc_TraceLine,origin,plOrigin,DONT_IGNORE_MONSTERS,start,tr);

	// hit the player, grenade ok
	if(get_tr2(tr,TR_pHit) == hit) return FMRES_IGNORED;

	// aim for the head
	pev(hit,pev_maxs,maxs);
	plOrigin[2] += maxs[2];
	engfunc(EngFunc_TraceLine,origin,plOrigin,DONT_IGNORE_MONSTERS,start,tr);

	// hit the player, grenade ok
	if(get_tr2(tr,TR_pHit) == hit) return FMRES_IGNORED;

	// aim for the feet
	pev(hit,pev_mins,mins);
	plOrigin[2] -= maxs[2]; // reverse above modification
	plOrigin[2] += mins[2];
	engfunc(EngFunc_TraceLine,origin,plOrigin,DONT_IGNORE_MONSTERS,start,tr);

	// hit the player, grenade ok
	if(get_tr2(tr,TR_pHit) == hit) return FMRES_IGNORED;

	// grenade could not hit body, head, or feet, find new target
	hit = engfunc(EngFunc_FindEntityInSphere,hit,origin,radius);

	forward_return(FMV_CELL,hit);
	return FMRES_SUPERCEDE;
 }
